function[Yall,spT]=LND_SLP(K,kList,id_expert,Y,Num)

% function [Yall,spT]=LND_SLP(K,kList,id_expert,Y)
% run Sequential Linear Program for different noise ratio in one run and detect noisy labels
% accoring to ratio of noise
% Input :  K = Kernel matrix 
%          KList = List of numbers of noisy points 
%          kList(i,:) = Denote i^th try of various noisy ratio 
%          kList(i,1) = Number of positively annotated datapoint is noisy.
%          kList(i,2) = Number of negatively annotated datapoint is noisy.
%          id_expert = List of index corresponding to expert annotation.
%          Y = Annotation
%          Num= Number of different intial points for avoiding local optimization  
% Output : Yall = Matrix of corrected labels. 
%          Yall(:,i)=  Corrected labels considering number of noisy data points in kList(i,:)
%          spT = time spent for noise detection

Q=diag(Y)*K*diag(Y);
init=rand(length(Y),Num);

for k=1:1:size(kList,1)
kL=kList(k,1:2);
obj_max(k)=-1.00e+20;
spT(k)=0;
for i=1:1:Num
p_init=init(:,i);
str=['Number of noisy data = [',num2str(kL(1)),',',num2str(kL(2)) '] and run = ', num2str(i)];
disp(str);
[pcur,obj,spentTime] = SLP(Q,kL,p_init,id_expert,Y);
if obj > obj_max(k)
obj_max(k)=obj;
P(:,k)=pcur;
end
spT(k)=spT(k)+spentTime;
end
Yall(:,k)=P(:,k).*Y;
Yall(find(Yall==0))=Y(find(Yall==0));
end
end
