function [Yall,spT]=LND_spanno(K,kList,id_expert,Y,nd)

% function [Yall,P,spT]=LND_spanno(K,kList,id_expert,Y,nd)
% run Spanno for different noise ratio in one run and detect noisy labels
% accoring to ratio of noise
% Input :  K = Kernel matrix 
%          KList = List of numbers of noisy points 
%          kList(i,:) = Denote i^th try of various noisy ratio 
%          kList(i,1) = Number of positively annotated datapoint is noisy.
%          kList(i,2) = Number of negatively annotated datapoint is noisy.
%          id_expert = List of index corresponding to expert annotation.
%          Y = Annotation
%          nd= Level of approximation
% Output : Yall = Matrix of corrected labels. 
%          Yall(:,i)=  Corrected labels considering number of noisy data points in kList(i,:)
%          spT = time spent for noise detection

st=cputime;
Q=diag(Y)*K*diag(Y);

if nd <=3
[P,obj]=Spanno(Q,Y,kList,id_expert,nd);
end

%elseif nd ==3
%[P,obj]=Spanno3(Q,Y,kList,id_expert);  
%else 
%    disp('Code is not available yet for approximarion > 3');
%end

for k=1:1:size(kList,1)
Yall(:,k)=P(:,k).*Y;
end
spT=cputime-st;
clear Feta eta;

end

