function [P,obj,spT] = SLP(Qall,kList,p_init,id_expert,Yall)

% Function [P,obj,spT] = SLP(Qall,kList,p_init,id_expert,Yall) execute Spanogram algortihm for nd=1 or 2 for  
% input :   Qall = diag(Y) *K* diag(Y)   matrix of all data point 
%           Yall = Annotation for all data points 
%           kList = List of numbers corresponing to noisy labels in positive class and negative class 
%           id_expert = List of index indicating datapoints annotated by experts
%           p_init = Intial value for P  
% output: P: probability of chance of being wrongly annotated
%         obj: objective value of optimization problem.
%         spT: Time required for noise detection.



non_expert=setdiff([1:1:length(Yall)],id_expert);
Q=[ Qall(non_expert,non_expert), sum(Qall(id_expert,non_expert),1)'; sum(Qall(id_expert,non_expert),1),sum(sum(Qall(id_expert,id_expert)))   ];
Q=0.5*(Q+Q');
Y=[Yall(non_expert);0];
eps=1E-6;

pold= ProjKlist(p_init,kList,Y);
pcur=pold;


disp('Running Sequential Linearization Program');
fcur=f(Q,pcur);


counter=1;
%display(['Iteration: ',num2str(counter),' - current value: ',num2str(fcur)]);
fiter(:,counter)=fcur;


diff=1.0e+20;

tstart=tic;
spentTime=0;
check=0;
while(diff>eps )

 % here define gradient
 pold=pcur;
fold=fcur;
 g=2*Q*pold;
pcur=ProjKlist(g,kList,Y);
fcur=f(Q,pcur);

 diff= (fcur-fold)/abs(fold);

   if(counter<20 | rem(counter,20)==1)
    display(['Iteration: ',num2str(counter),' - current value: ',num2str(fcur,'%1.10f'),' - Obj diff: ',num2str(diff,'%1.10f')]);%,'; current stepsize: ',num2str(step) ]);
    fiter=[fiter fcur]; spentTime=[spentTime, toc(tstart)]; 
 
   end
  if (counter >10000  )
   P=ones(size(Yall));
if diff<eps
pcur=pold;
fcur=fold
end
   P(non_expert(find(pcur==-1)))=-1;
   obj=fcur;
iterations=counter;
spT=spentTime(length(spentTime));

return;
  end


end
display(['Iteration: ',num2str(counter),' - current value: ',num2str(fcur,'%1.10f'),' - Obj diff: ',num2str(diff,'%1.10f')]);%,'; current stepsize: ',num2str(step) ]);
counter=counter+1;   
P=ones(size(Yall));
   P(non_expert(find(pcur==-1)))=-1;

obj=fcur;
iterations=counter;
spT=spentTime(length(spentTime));
end



function fval = f(Q,P)
fval = P'*Q*P ;
%fval =(ones(length(P),1)-2*P)'*Q*(ones(length(P),1)-2*P)  - C*sum(P);

end
function [Pprob]=ProjKlist(genP,kList,Y)
idP=find(Y==1);
idN=find(Y==-1);

[~,PidP]=sort(genP(idP),'ascend');
[~,PidN]=sort(genP(idN),'ascend');
kp=kList(1);
kn=kList(2);
tempP=idP(PidP(1:kp));

if size(tempP,1)>1
tempP=tempP';
end
tempN=idN(PidN(1:kn));

if size(tempN,1)>1
tempN=tempN';
end


id=[tempP,tempN];
Pprob=ones(length(Y),1);
Pprob(id)=-1;
end

